/* eslint-disable @typescript-eslint/naming-convention */
// store 可通过 tabid (前后端通信可能用到，ValueChangeListener 会返回 tabid)，获取 storeid，后台脚本用
declare namespace TampermonkeyBeta {
  type CookieAction = 'list' | 'delete' | 'set' | 'store' | undefined;

  interface Cookie {
    url?: string | undefined;
    name?: string | undefined;
    value?: string | undefined;
    domain?: string | undefined;
    path?: string | undefined;
    secure?: boolean | undefined;
    session?: boolean | undefined;
    storeId?: string | undefined;
    httpOnly?: boolean | undefined;
    expirationDate?: number | undefined;
  }
}

declare function GM_cookie(
  action: TampermonkeyBeta.CookieAction,
  details: TampermonkeyBeta.Cookie,
  ondone: (cookie: TampermonkeyBeta.Cookie[], error: Error | undefined) => void
): void;
